RunApp(3pm)

NAME
RunApp - A generic module to run web-applications

SYNOPSIS
 use RunApp '-chdir';

 use RunApp;
 use RunApp::Apache;

 my $cmd = shift || 'development';
 my $config = { var => 'value', app_apache => { var_for_apache => 'value'} };
 RunApp->new (app_apache => RunApp::Apache->new
                    (root => catfile (cwd, $_),
                     httpd => '/path/to/httpd'),
              my_daemon => RunApp::Control::AppControl->new
                    (binary => '/path/to/daemon',
                     args => ['--daemon'],
                     pidfile => '/path/to/daemon.pid',
                    )
                 )->$cmd ($config);

DESCRIPTION
"RunApp" streamlines the process for configuring applications that requires one or more web servers and/or other daemons, during development or deployment.

It builds the config files required by the services from the $config hash, such as apache's httpd.conf.

OPTIONS
 use RunApp '-chdir';
 use RunApp qw(-chdir ..);

This will cause the your script to "chdir" to the base directory. If it's a symbolic link it will be resolved and you will be in the directory of where the original script is. The "lib" directory will be added into @INC, and you can use the modules in that path.

It also takes an optional relative path if want the script to chdir to somewhere else.

This makes it possible for symlinking the your runapp script into system's rc.d startup directory.

CONSTRUCTOR

  new (@services)
@services is actually an hash, with keys being the name of the service, and values being "RunApp::Control" objects. Use an array instead of a hash here to retain the order of dispatching.

The names are used to pick config from the hash, which will be flatten into top level of the config hash, when running "build" for the each service.

METHODS

  $self->development ($conf)
Runs "build" and "start", and then waits for SIGINT to <stop> the servers.

AUTOLOAD
All other methods are dispatched to the "RunApp::Control" objects in the order called in CONSTRUCTOR. Note that this is done with RunApp::Control dispatching to the "dispatch" method.

SEE ALSO
RunApp::Apache, RunApp::Control::AppControl, App::Control

AUTHORS
Chia-liang Kao <clkao@clkao.org>

Refactored from works by Leon Brocard <acme@astray.com> and Tom Insam <tinsam@fotango.com>.

COPYRIGHT
Copyright (C) 2002-5, Fotango Ltd.

This module is free software; you can redistribute it or modify it under the same terms as Perl itself.